package msgpack.rpcx.auth

import java.util. { Timer, TimerTask }

import org.joda.time.LocalDateTime

/** Schedules time expiration.
 *
 * @author myst3r10n
 */
class LoginScheduler {

  /** Scheduler. */
  protected val scheduler = new Timer

  /** Expire of login in seconds. */
  var expire = 0

  /** Starts scheduler.
   *
   * @param loginMap reference to login informations
   * @param expire time in seconds
   */
  def start(loginMap: LoginMap, expire: Int) {

    scheduler.schedule(new TimerTask() {

      def run {

        if(expire < 1)
          return

        val now = new LocalDateTime

        loginMap.foreach { case (authId, info) =>

          if(now.compareTo(info.timestamp.plusSeconds(expire)) < 0)
            loginMap -= authId

        }

      }
    }, 1000)
  }

  /** Cancels scheduler. */
  def cancel {

    scheduler.cancel

  }
}

